No video

Remove K Digits - Leetcode 402 - Python

  Рет қаралды 61,018

NeetCode

NeetCode

Күн бұрын

Пікірлер: 100
@CJ-ot2pg
@CJ-ot2pg 2 жыл бұрын
Hey, I almost never comment on yt vids, but I've been studying almost exclusively through your videos for the last 2 months and I just received 3 offers this week 😭. This is life-changing for me, and I can't thank you enough. Please keep up the great work. Will be subscribing to your Patreon, even though I know that doesn't even come close to repaying you for how much you've helped all of us. Thank you so, so much for what you're doing ❤ 🙏
@mikeyfeeney4294
@mikeyfeeney4294 2 жыл бұрын
Congrats, best of luck! :)
@NeetCode
@NeetCode 2 жыл бұрын
Congratulations 🙂🎉🎉
@sumosam1980
@sumosam1980 2 жыл бұрын
Congratulations! Truly amazing! Best wishes on your future endeavors and may all the viewers of this channel learn and reach their dreams!
@kigarde
@kigarde 2 жыл бұрын
Congratulations. !!!!
@killpointx
@killpointx 4 ай бұрын
New test case is failing this code. string is very large So cannot convert to int. i used while stack and stack[0]=="0": stack = satck[1:] or result = ''.join(stack).lstrip('0')
@licokr
@licokr 4 ай бұрын
javascript code for this. while (answer.length > 0 && answer[0] === '0') answer.shift(); if (answer.length === 0) answer = '0'; else answer = answer.join('');
@akurabravery1810
@akurabravery1810 4 ай бұрын
1. Use the string method lstrip to remove the "0" from the left. 2. A loop and a pointer that run while the num at pointer is equals to "0". and use that index to ignore the leading zeros in the join. 3. instead of a stack, a queue could solve this leading zero issue efficiently while keeping the solution the same.
@rxpt0rs
@rxpt0rs 2 жыл бұрын
I don't know why but I feel so much joy when you say "yes it does, and it's very efficient". I think these coding problems have gotten to me.
@user-kt4gp5fb8q
@user-kt4gp5fb8q 4 ай бұрын
Latest test cases it give TLE, here is the updated one if someone is interested class Solution: def removeKdigits(self, num: str, k: int) -> str: stack = [] for val in num: while k>0 and stack and stack[-1]>val: k-=1 stack.pop() if not stack and val=='0': continue stack.append(val) res = ''.join(stack) if k>0: res = res[:len(res)-k] return res if res else '0'
@dagi_works
@dagi_works 4 ай бұрын
You dropped this 👑.
@hen56349
@hen56349 3 ай бұрын
@@dagi_works facts🤣🤣
@user-fk1zp5gk1o
@user-fk1zp5gk1o 2 ай бұрын
No need to heck if k>0 if it is zero then we would still have the same answer but I guess it would simplify things ofr the interviewer
@chinesemimi
@chinesemimi 2 жыл бұрын
Neetcode, you helped me get a job! Thank you so much! Your explanations are the best on youtube!
@VrickzGamer
@VrickzGamer 2 жыл бұрын
This problem literally caused me a headache yesterday , this is not at all medium problem
@chagsssss
@chagsssss 2 жыл бұрын
I have been following you for a month. I try to solve a problem and regardless of whether I am able to solve it or not, I watch your videos as it makes me learn something vital. Do you have any tips to improve the problem solving ability?
@vdyb745
@vdyb745 2 жыл бұрын
Every time you say "Thanks for watching" I feel like saying a heartfelt "Thanks for posting" !!!!! You are awesome !!!
@rideravi6999
@rideravi6999 Жыл бұрын
logic to strip leading zeros needed to be modified otherwise I am getting below error ValueError: Exceeds the limit (4300) for integer string conversion: value has 9001 digits; use sys.set_int_max_str_digits() to increase the limit
@rideravi6999
@rideravi6999 Жыл бұрын
used the below logic to solve the error if res: for i, s in enumerate(res): if s != '0': break return res[i:] else: return "0"
@leeroymlg4692
@leeroymlg4692 Жыл бұрын
@@rideravi6999 another way to do it is not add 0 to the stack if the stack is empty and the character is 0. you can add this before stack.append(c) if not stack and c == '0': continue
@monicatare6536
@monicatare6536 6 ай бұрын
Updated last two lines to these to avoid above error: res = "".join(stack).lstrip("0") return res if res else "0"
@alokesh985
@alokesh985 2 жыл бұрын
Instead of removing the leading zeros at the end, you could just have a condition inside of the loop, that if the stack is empty, and value of c is '0', then just continue to the next iteration of the loop
@nguyenhoanvule5755
@nguyenhoanvule5755 2 жыл бұрын
That's good. Thanks
@jenishsoni10
@jenishsoni10 2 жыл бұрын
Great explanation though! I have a small question: when in the returning statement we are converting the string to int to avoid trailing zeroes, but the size of the string is 10^5, wouldn't that overflow the int limit? [For example in java If I did that then it would make the max value as (2^31 - 1) instead of our actual string] Please advise.
@NeetCode
@NeetCode 2 жыл бұрын
That's a really good point actually, it only works in python because numbers are not limited in bits. But yeah in most languages you would have to handle it differently.
@anishdeshmukh4690
@anishdeshmukh4690 2 жыл бұрын
You can use the lstrip function to remove leading zeroes. This way you don't need to convert the string to an integer.
@nammi895
@nammi895 3 ай бұрын
This question was asked in an interview, needless to say I haven't seen it before & its very hard to comp up with an algo like this Verdict : REJECTED
@nishantingle1438
@nishantingle1438 2 жыл бұрын
Hope this question saves Meta stock 🔥
@NeetCode
@NeetCode 2 жыл бұрын
lol
@BarneyBing883
@BarneyBing883 2 жыл бұрын
I can't thank you enough for creating this channel and being such a good teacher! This problem in particular had been too hard for me for a very long time, but this video makes it so much simpler to understand. But in general, watching your videos has actually made me better at algorithms than I ever was and I could see that difference in every interview I give.
@ajinkyapahinkar6463
@ajinkyapahinkar6463 Жыл бұрын
I tried to come up with a solution using recursion but its not that efficient was able to run only half the testcases before running into tle: class Solution: def helper(self, num, k, res = []): if k == 0: if num: res.append(int(num)) else: res.append(0) return for i in range(len(num)): if i!=len(num) - 1: self.helper(num[0:i] + num[i+1:], k-1, res) else: self.helper(num[0:-1], k-1, res) return str(min(res)) def removeKdigits(self, num: str, k: int) -> str: res = [] return self.helper(num, k, res)
@johnj171
@johnj171 3 ай бұрын
Did you know you are "The Godfather" of Teaching coding this consistently
@VrickzGamer
@VrickzGamer 2 жыл бұрын
Your videos are most explained of all the available channels
@mykytapiskarov7291
@mykytapiskarov7291 Жыл бұрын
Thanks for the video solution @NeetCode, as always simple and clear! One note for Java devs: In Java parseInt won't work to remove leading zeroes(it throws NumberFormatException) since num could be larger than Integer.MAX_VALUE given the constraints of problem: 1
@anonymy834
@anonymy834 Жыл бұрын
hi why this piece of code ended with the error of "ValueError: Exceeds the limit (4300) for integer string conversion: value has 9001 digits; use sys.set_int_max_str_digits() to increase the limit return str(int(res)) if res else '0'" in my console?
@beonthego8725
@beonthego8725 11 ай бұрын
these should be the last 2 lines res = "".join(stack).lstrip("0") return res if res else "0"
@shubhamsantoki5265
@shubhamsantoki5265 2 жыл бұрын
your videos got me intrested in leetcode/programming.thanks a lot.🙏
@haroldobasi2545
@haroldobasi2545 2 жыл бұрын
Great video, I was thinking If there is a possible decision tree/recursive approach that can be used here
@SairamDasari2000
@SairamDasari2000 8 ай бұрын
When you asked which data structure to use i thought of monotonic stack(because of one your previous videos) ,rn I'm so obsessed with your explanations 😭
@FCBarcelonaXMI
@FCBarcelonaXMI 2 жыл бұрын
I think you forget to edit out 4:09, had me confused for a minute :D Regardless, great video again thanks for the work you do!
@NeetCode
@NeetCode 2 жыл бұрын
whoops, luckily youtube lets you edit videos after uploading. should be fixed in a couple hours :)
@annbrown8069
@annbrown8069 2 жыл бұрын
Thank you so much for the explanation, otherwise, I would never have understood the question's expectation. Can you please help me think about how to analyze if the k digits should be removed in a sequence or subsequence? Because it was not clear in the question as well as the sample test cases. What I believe is when a person will fail many test cases or unless given a hint, then he would be able to realize something. What do you think?
@JLSXMK8
@JLSXMK8 4 ай бұрын
UPDATE: As of 2024 April 11, That conversion to an int and back to a string will not work. Instead, you can use "res = res.lstrip("0")" to remove all the leading zeros from the string. Just in case you're trying that last line and wanna rip your hair out when it doesn't work!
@anjanobalesh8046
@anjanobalesh8046 Жыл бұрын
We can use string instead of stack in languages where stack doesn't exist. So pop becomes removing last element from the string and spend becomes spending to that same string
@licokr
@licokr 4 ай бұрын
It took me some time to get a sense of the solution.. I think I didn't consider the order of the number cause the order of the number would be the same. The key points I understood is that getting rid of big nth numbers in front of the number because it leads to reduce the total number. and the k part is when there is still k numbers to delete left. We simply delete the last k elements because if they are bigger than the front of numbers, it would have been deleted by the logic in the loop. So it deletes k numbers from the rare. This is what I understood, Is it alright?
@hoangvietng7100
@hoangvietng7100 4 ай бұрын
You are my fav teacher, thank you for all
@sharksinvestment9864
@sharksinvestment9864 Жыл бұрын
Thanks neetcode for great explanation
@xianweiwu1843
@xianweiwu1843 9 ай бұрын
Thx neetcode! Your videos really helped me a lot! :)
@chaengsaltz829
@chaengsaltz829 2 жыл бұрын
Great solution and explanation, as always. Thanks for posting the vdo. Keep up the fantastic work!!! looking forward to more :)
@MP-ny3ep
@MP-ny3ep 4 ай бұрын
Phenomenal explanation as always. Thank you
@jaatharsh
@jaatharsh 4 ай бұрын
this is awesome explanation, thanks a lot buddy
@raidyqk
@raidyqk 4 ай бұрын
3:59 Didn't knew Neetcode is german
@user-xi6jz3fb4u
@user-xi6jz3fb4u Жыл бұрын
Thanks for the clear algorithm explaination, it really hepls me a lot >.
@vijethkashyap151
@vijethkashyap151 4 ай бұрын
Best ever!
@abhishekseth7187
@abhishekseth7187 Жыл бұрын
you made it so easy....thanks man
@andrepinto7895
@andrepinto7895 2 жыл бұрын
You can do stack[:-k] (no need for length)
@shashankgarg7476
@shashankgarg7476 Жыл бұрын
You are such a great soul!
@__________________________6910
@__________________________6910 2 жыл бұрын
ha ha I just did it yesterday.... and looking for your solution.... here is it 😁
@Gustavo-ve9hr
@Gustavo-ve9hr 2 жыл бұрын
Thank you for your explanation !
@amanavengeraman
@amanavengeraman 2 жыл бұрын
Nicely Explained
@vinaypawde9894
@vinaypawde9894 2 жыл бұрын
So elegant..kudos..!!
@user-rv1bx8hx4v
@user-rv1bx8hx4v 4 ай бұрын
Thank you! 👍👍
@ajayjangid1164
@ajayjangid1164 Жыл бұрын
super explanation👍👍
@xybnedasdd2930
@xybnedasdd2930 Жыл бұрын
Alternative: if the goal is to remove K digits to find the lowest value, then we can rephrase this as: - find the subsequence of length solutionLen = N - K which represents the smallest numeric value Then we can implement this by iterating (N-K times) by selecting the smallest value from left up to some maximum ending index, where max ending index is calculated to be N - solutionLen + i (where i is our iteration index) In each iteration we select the smallest value and its corresponding index, and then enter the next iteration to search for the next minimum value, starting with the last iteration's corresponding idx. This has naievely N squared time complexity, but we can use a segment tree to efficiently get minimums in a segment, so that our minimum search aborts early (in constant time aggregated).
@krateskim4169
@krateskim4169 4 ай бұрын
Thank you so much
@ChandraShekhar-by3cd
@ChandraShekhar-by3cd 2 жыл бұрын
Thanks NeetCode such a great explantion. Could you please suggest some resources to read about Sytem design and Low level design, I have an upcoming rounds..Thanks and many congratulations for The Google!!
@pawananubhav12
@pawananubhav12 2 жыл бұрын
da best explanation like always
@krishnakshirsagar4570
@krishnakshirsagar4570 2 жыл бұрын
Hard thing is to come up with algorithm / logic
@pollathajeeva23
@pollathajeeva23 2 жыл бұрын
Please make the videos on all types of algorithms which are use in problem solving dedicated one please.
@syedaqib2912
@syedaqib2912 2 жыл бұрын
The tags in thumbnail are from leetcode premium?😅
@prathamtyagi5914
@prathamtyagi5914 Жыл бұрын
i wanna know how that string(int(res)) works? why didn't it threw out of range exception at higher ranges??
@samarthjain5015
@samarthjain5015 4 ай бұрын
10:03 You should have said "non-decreasing order" instead of "increasing order". That's how leetcode frames the question.
@andreytamelo1183
@andreytamelo1183 2 жыл бұрын
Thanks!
@thejasnaik4694
@thejasnaik4694 4 ай бұрын
I kept getting the error: ValueError: Exceeds the limit (4300 digits) for integer string conversion: value has 9001 digits; use sys.set_int_max_str_digits() to increase the limit Had to fix it by including: import sys sys.set_int_max_str_digits(0) I'm surprised that the test cases passed for you without having to encounter this error. :/
@BurhanAijaz
@BurhanAijaz 4 ай бұрын
He solved it 2 years ago so back then there might have been less test cases
@chuckle_pugz96
@chuckle_pugz96 4 ай бұрын
doing it manually after the for loop solved it for me: #if k>0, then remove k elements from right/end. while k>0 and stack: stack.pop() k-=1 #if there are leading zeros. while stack and stack[0]=="0": stack.pop(0) res = "".join(stack) return res if res else "0"
@ravindrabhatt
@ravindrabhatt 2 жыл бұрын
why do we need while? can we not do with if else?
@thanirmalai
@thanirmalai Жыл бұрын
I got the exact same intuition and conceptual approach but i cant implement in code. I found my mistake it was about the unremoved k integers from the back of the number
@VarunSharma-xd8xd
@VarunSharma-xd8xd 4 ай бұрын
the best
@VrickzGamer
@VrickzGamer 2 жыл бұрын
How did you know I was desperately searching for this problem from yesterday
@akashverma5756
@akashverma5756 10 ай бұрын
Easy to solve intuitively but hard to implement.
@jugsma6676
@jugsma6676 2 жыл бұрын
Hi NeetCode, this is my solution: would this work? def remove_k_digits(nums, k): if len(nums) 0: removal_stack = [] for i in range(len(nums)): d_remove = nums[:i] + nums[i+1:] removal_stack.append(d_remove) max_val = min(removal_stack) idx = removal_stack.index(max_val) nums = nums[:idx] + nums[idx+1:] k -= 1 return str(int(nums))
@09sangram
@09sangram Жыл бұрын
Awesome
@infoknow3278
@infoknow3278 Жыл бұрын
the code is not working ValueError: Exceeds the limit (4300) for integer string conversion: value has 9001 digits; use sys.set_int_max_str_digits() to increase the limit return str(int(res)) if res else "0" Line 15 in removeKdigits (Solution.py) ret = Solution().removeKdigits(param_1, param_2) Line 43 in _driver (Solution.py) _driver() Line 54 in (Solution.py) what to do ?
@beonthego8725
@beonthego8725 11 ай бұрын
these should be the last 2 lines res = "".join(stack).lstrip("0") return res if res else "0"
@lakshaygupta5268
@lakshaygupta5268 Жыл бұрын
isnt the smallest number 1122 in the solve example thou
@midhileshmomidi3120
@midhileshmomidi3120 2 жыл бұрын
Is the time complexity n^2 because of while loop
@nityanandbhaskar2155
@nityanandbhaskar2155 Жыл бұрын
no. its just O(N) . Overall we are traversing the string and stack only once.
@vishaalkumaranandan2894
@vishaalkumaranandan2894 4 ай бұрын
Runtime error ValueError: Exceeds the limit (4300 digits) for integer string conversion: value has 9001 digits; use sys.set_int_max_str_digits() to increase the limit ^^^^^^^^ return str(int(res)) if res else "0" Line 11 in removeKdigits (Solution.py) ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ ret = Solution().removeKdigits(param_1, param_2) Line 35 in _driver (Solution.py) _driver() Line 46 in (Solution.py)
@shashivish2022
@shashivish2022 4 ай бұрын
stack = [] for c in num : while k > 0 and stack and stack[-1] > c: k -=1 stack.pop() stack.append(c) stack = "".join(stack[:len(stack)-k]) return stack.lstrip("0") or "0"
@ASWANTHMANCHALA
@ASWANTHMANCHALA 4 ай бұрын
is my logic valid please help me to fix it ....... am i in right direction ? class Solution: def removeKdigits(self, num: str, k: int) -> str: if k >= len(num): return '0' m = float('inf') for i in range(len(num)): x = int(num[:i] + num[i+k:]) m = min(m, x) m = str(m) return m if m else '0'
@managerbmr
@managerbmr 2 жыл бұрын
Can you do leetcode 828??
@SANJAYSINGH-jt4hf
@SANJAYSINGH-jt4hf Жыл бұрын
Java Solution: class Solution { public String removeKdigits(String num, int k) { if(num.length()==k) return "0"; ArrayDeque stk = new ArrayDeque(); for(int i=0;i (val-'0') && k>0){ stk.pop();k--; } stk.push(val); } String res=""; while(!stk.isEmpty() && k>0){stk.pop();k--;} //k still >0 so remove big nums while(!stk.isEmpty()){res=stk.pop()+res;} while(res.length()>1 && res.charAt(0)=='0') {res=res.substring(1,res.length());} //remove leading 0s return res; } }
@cfbf96
@cfbf96 Жыл бұрын
man i feel so dumb everytime i see these leetcode videos, i'll never have a good job =/
@krishnakshirsagar4570
@krishnakshirsagar4570 2 жыл бұрын
I have a coding test in some days if you can help i will pay! 3 problems easy medium hard need help for medium and hard
@mehrdadmirpourian64
@mehrdadmirpourian64 2 жыл бұрын
Amazing. Thank you
Valid Parenthesis String - Leetcode 678 - Python
13:43
NeetCode
Рет қаралды 67 М.
4Sum - Leetcode 18 - Python
15:28
NeetCode
Рет қаралды 77 М.
Zombie Boy Saved My Life 💚
00:29
Alan Chikin Chow
Рет қаралды 34 МЛН
Largest Number - Leetcode 179 - Python
10:17
NeetCode
Рет қаралды 55 М.
Snakes and Ladders - Leetcode 909 - Python
21:22
NeetCode
Рет қаралды 50 М.
Insert Delete GetRandom O(1) - Leetcode 380 - Python
13:27
NeetCode
Рет қаралды 44 М.
Reverse Linked List II - Leetcode 92 - Python
16:03
NeetCode
Рет қаралды 78 М.
Permutation in String - Leetcode 567 - Python
19:40
NeetCode
Рет қаралды 214 М.
132 Pattern - Leetcode 456 - Python
12:02
NeetCode
Рет қаралды 61 М.